Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3981)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3982)
@@ -26,27 +26,10 @@
 #define DEFAULT_RTP_PORT	4000
 
-#define NULL_SND_DEV_ID		-99
-
 #ifndef PJSUA_REQUIRE_CONSECUTIVE_RTCP_PORT
 #   define PJSUA_REQUIRE_CONSECUTIVE_RTCP_PORT	0
 #endif
 
-
 /* Next RTP port to be used */
 static pj_uint16_t next_rtp_port;
-
-/* Open sound dev */
-static pj_status_t open_snd_dev(pjmedia_snd_port_param *param);
-/* Close existing sound device */
-static void close_snd_dev(void);
-/* Create audio device param */
-static pj_status_t create_aud_param(pjmedia_aud_param *param,
-				    pjmedia_aud_dev_index capture_dev,
-				    pjmedia_aud_dev_index playback_dev,
-				    unsigned clock_rate,
-				    unsigned channel_count,
-				    unsigned samples_per_frame,
-				    unsigned bits_per_sample);
-
 
 static void pjsua_media_config_dup(pj_pool_t *pool,
@@ -65,11 +48,5 @@
 pj_status_t pjsua_media_subsys_init(const pjsua_media_config *cfg)
 {
-    pj_str_t codec_id = {NULL, 0};
-    unsigned opt;
-    pjmedia_audio_codec_config codec_cfg;
     pj_status_t status;
-
-    /* To suppress warning about unused var when all codecs are disabled */
-    PJ_UNUSED_ARG(codec_id);
 
     pj_log_push_indent();
@@ -116,135 +93,7 @@
     }
 
-    /*
-     * Register all codecs
-     */
-    pjmedia_audio_codec_config_default(&codec_cfg);
-    codec_cfg.speex.quality = pjsua_var.media_cfg.quality;
-    codec_cfg.speex.complexity = -1;
-    codec_cfg.ilbc.mode = pjsua_var.media_cfg.ilbc_mode;
-
-#if PJMEDIA_HAS_PASSTHROUGH_CODECS
-    /* Register passthrough codecs */
-    {
-	unsigned aud_idx;
-	unsigned ext_fmt_cnt = 0;
-	pjmedia_format ext_fmts[32];
-
-	/* List extended formats supported by audio devices */
-	for (aud_idx = 0; aud_idx < pjmedia_aud_dev_count(); ++aud_idx) {
-	    pjmedia_aud_dev_info aud_info;
-	    unsigned i;
-	    
-	    status = pjmedia_aud_dev_get_info(aud_idx, &aud_info);
-	    if (status != PJ_SUCCESS) {
-		pjsua_perror(THIS_FILE, "Error querying audio device info",
-			     status);
-		goto on_error;
-	    }
-	    
-	    /* Collect extended formats supported by this audio device */
-	    for (i = 0; i < aud_info.ext_fmt_cnt; ++i) {
-		unsigned j;
-		pj_bool_t is_listed = PJ_FALSE;
-
-		/* See if this extended format is already in the list */
-		for (j = 0; j < ext_fmt_cnt && !is_listed; ++j) {
-		    if (ext_fmts[j].id == aud_info.ext_fmt[i].id &&
-			ext_fmts[j].det.aud.avg_bps ==
-			aud_info.ext_fmt[i].det.aud.avg_bps)
-		    {
-			is_listed = PJ_TRUE;
-		    }
-		}
-		
-		/* Put this format into the list, if it is not in the list */
-		if (!is_listed)
-		    ext_fmts[ext_fmt_cnt++] = aud_info.ext_fmt[i];
-
-		pj_assert(ext_fmt_cnt <= PJ_ARRAY_SIZE(ext_fmts));
-	    }
-	}
-
-	/* Init the passthrough codec with supported formats only */
-	codec_cfg.passthrough.setting.fmt_cnt = ext_fmt_cnt;
-	codec_cfg.passthrough.setting.fmts = ext_fmts;
-	codec_cfg.passthrough.setting.ilbc_mode = cfg->ilbc_mode;
-    }
-#endif /* PJMEDIA_HAS_PASSTHROUGH_CODECS */
-
-    /* Register all codecs */
-    status = pjmedia_codec_register_audio_codecs(pjsua_var.med_endpt,
-                                                 &codec_cfg);
-    if (status != PJ_SUCCESS) {
-	PJ_PERROR(1,(THIS_FILE, status, "Error registering codecs"));
+    status = pjsua_aud_subsys_init();
+    if (status != PJ_SUCCESS)
 	goto on_error;
-    }
-
-    /* Set speex/16000 to higher priority*/
-    codec_id = pj_str("speex/16000");
-    pjmedia_codec_mgr_set_codec_priority(
-	pjmedia_endpt_get_codec_mgr(pjsua_var.med_endpt),
-	&codec_id, PJMEDIA_CODEC_PRIO_NORMAL+2);
-
-    /* Set speex/8000 to next higher priority*/
-    codec_id = pj_str("speex/8000");
-    pjmedia_codec_mgr_set_codec_priority(
-	pjmedia_endpt_get_codec_mgr(pjsua_var.med_endpt),
-	&codec_id, PJMEDIA_CODEC_PRIO_NORMAL+1);
-
-    /* Disable ALL L16 codecs */
-    codec_id = pj_str("L16");
-    pjmedia_codec_mgr_set_codec_priority( 
-	pjmedia_endpt_get_codec_mgr(pjsua_var.med_endpt),
-	&codec_id, PJMEDIA_CODEC_PRIO_DISABLED);
-
-
-    /* Save additional conference bridge parameters for future
-     * reference.
-     */
-    pjsua_var.mconf_cfg.channel_count = pjsua_var.media_cfg.channel_count;
-    pjsua_var.mconf_cfg.bits_per_sample = 16;
-    pjsua_var.mconf_cfg.samples_per_frame = pjsua_var.media_cfg.clock_rate * 
-					    pjsua_var.mconf_cfg.channel_count *
-					    pjsua_var.media_cfg.audio_frame_ptime / 
-					    1000;
-
-    /* Init options for conference bridge. */
-    opt = PJMEDIA_CONF_NO_DEVICE;
-    if (pjsua_var.media_cfg.quality >= 3 &&
-	pjsua_var.media_cfg.quality <= 4)
-    {
-	opt |= PJMEDIA_CONF_SMALL_FILTER;
-    }
-    else if (pjsua_var.media_cfg.quality < 3) {
-	opt |= PJMEDIA_CONF_USE_LINEAR;
-    }
-	
-    /* Init conference bridge. */
-    status = pjmedia_conf_create(pjsua_var.pool, 
-				 pjsua_var.media_cfg.max_media_ports,
-				 pjsua_var.media_cfg.clock_rate, 
-				 pjsua_var.mconf_cfg.channel_count,
-				 pjsua_var.mconf_cfg.samples_per_frame, 
-				 pjsua_var.mconf_cfg.bits_per_sample, 
-				 opt, &pjsua_var.mconf);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error creating conference bridge", 
-		     status);
-	goto on_error;
-    }
-
-    /* Are we using the audio switchboard (a.k.a APS-Direct)? */
-    pjsua_var.is_mswitch = pjmedia_conf_get_master_port(pjsua_var.mconf)
-			    ->info.signature == PJMEDIA_CONF_SWITCH_SIGNATURE;
-
-    /* Create null port just in case user wants to use null sound. */
-    status = pjmedia_null_port_create(pjsua_var.pool, 
-				      pjsua_var.media_cfg.clock_rate,
-				      pjsua_var.mconf_cfg.channel_count,
-				      pjsua_var.mconf_cfg.samples_per_frame,
-				      pjsua_var.mconf_cfg.bits_per_sample,
-				      &pjsua_var.null_port);
-    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
 
 #if defined(PJMEDIA_HAS_SRTP) && (PJMEDIA_HAS_SRTP != 0)
@@ -273,80 +122,4 @@
 }
 
-
-/* Check if sound device is idle. */
-static void check_snd_dev_idle()
-{
-    unsigned call_cnt;
-
-    /* Check if the sound device auto-close feature is disabled. */
-    if (pjsua_var.media_cfg.snd_auto_close_time < 0)
-	return;
-
-    /* Check if the sound device is currently closed. */
-    if (!pjsua_var.snd_is_on)
-	return;
-
-    /* Get the call count, we shouldn't close the sound device when there is
-     * any calls active.
-     */
-    call_cnt = pjsua_call_get_count();
-
-    /* When this function is called from pjsua_media_channel_deinit() upon
-     * disconnecting call, actually the call count hasn't been updated/
-     * decreased. So we put additional check here, if there is only one
-     * call and it's in DISCONNECTED state, there is actually no active
-     * call.
-     */
-    if (call_cnt == 1) {
-	pjsua_call_id call_id;
-	pj_status_t status;
-
-	status = pjsua_enum_calls(&call_id, &call_cnt);
-	if (status == PJ_SUCCESS && call_cnt > 0 &&
-	    !pjsua_call_is_active(call_id))
-	{
-	    call_cnt = 0;
-	}
-    }
-
-    /* Activate sound device auto-close timer if sound device is idle.
-     * It is idle when there is no port connection in the bridge and
-     * there is no active call.
-     */
-    if (pjsua_var.snd_idle_timer.id == PJ_FALSE &&
-	call_cnt == 0 &&
-	pjmedia_conf_get_connect_count(pjsua_var.mconf) == 0)
-    {
-	pj_time_val delay;
-
-	delay.msec = 0;
-	delay.sec = pjsua_var.media_cfg.snd_auto_close_time;
-
-	pjsua_var.snd_idle_timer.id = PJ_TRUE;
-	pjsip_endpt_schedule_timer(pjsua_var.endpt, &pjsua_var.snd_idle_timer,
-				   &delay);
-    }
-}
-
-
-/* Timer callback to close sound device */
-static void close_snd_timer_cb( pj_timer_heap_t *th,
-				pj_timer_entry *entry)
-{
-    PJ_UNUSED_ARG(th);
-
-    PJSUA_LOCK();
-    if (entry->id) {
-	PJ_LOG(4,(THIS_FILE,"Closing sound device after idle for %d seconds",
-		  pjsua_var.media_cfg.snd_auto_close_time));
-
-	entry->id = PJ_FALSE;
-
-	close_snd_dev();
-    }
-    PJSUA_UNLOCK();
-}
-
-
 /*
  * Start pjsua media subsystem.
@@ -375,6 +148,10 @@
 #endif
 
-    pj_timer_entry_init(&pjsua_var.snd_idle_timer, PJ_FALSE, NULL,
-			&close_snd_timer_cb);
+    /* Audio */
+    status = pjsua_aud_subsys_start();
+    if (status != PJ_SUCCESS) {
+	pj_log_pop_indent();
+	return status;
+    }
 
     /* Video */
@@ -382,4 +159,5 @@
     status = pjsua_vid_subsys_start();
     if (status != PJ_SUCCESS) {
+	pjsua_aud_subsys_destroy();
 	pj_log_pop_indent();
 	return status;
@@ -408,30 +186,6 @@
     pj_log_push_indent();
 
-    close_snd_dev();
-
-    if (pjsua_var.mconf) {
-	pjmedia_conf_destroy(pjsua_var.mconf);
-	pjsua_var.mconf = NULL;
-    }
-
-    if (pjsua_var.null_port) {
-	pjmedia_port_destroy(pjsua_var.null_port);
-	pjsua_var.null_port = NULL;
-    }
-
-    /* Destroy file players */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua_var.player); ++i) {
-	if (pjsua_var.player[i].port) {
-	    pjmedia_port_destroy(pjsua_var.player[i].port);
-	    pjsua_var.player[i].port = NULL;
-	}
-    }
-
-    /* Destroy file recorders */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua_var.recorder); ++i) {
-	if (pjsua_var.recorder[i].port) {
-	    pjmedia_port_destroy(pjsua_var.recorder[i].port);
-	    pjsua_var.recorder[i].port = NULL;
-	}
+    if (pjsua_var.med_endpt) {
+	pjsua_aud_subsys_destroy();
     }
 
@@ -1328,6 +1082,6 @@
 
 /* Set media transport state and notify the application via the callback. */
-void set_media_tp_state(pjsua_call_media *call_med,
-                        pjsua_med_tp_st tp_st)
+void pjsua_set_media_tp_state(pjsua_call_media *call_med,
+                              pjsua_med_tp_st tp_st)
 {
     if (pjsua_var.ua_cfg.cb.on_call_media_transport_state &&
@@ -1363,5 +1117,5 @@
 
     if (call_med->tp_st == PJSUA_MED_TP_CREATING)
-        set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
+        pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
 
     if (!call_med->tp_orig &&
@@ -1467,24 +1221,13 @@
     if (call_med->tp == NULL) {
 #if defined(PJMEDIA_HAS_VIDEO) && (PJMEDIA_HAS_VIDEO != 0)
-	pjsua_acc *acc = &pjsua_var.acc[call_med->call->acc_id];
-
 	/* While in initial call, set default video devices */
 	if (type == PJMEDIA_TYPE_VIDEO) {
-	    call_med->strm.v.rdr_dev = acc->cfg.vid_rend_dev;
-	    call_med->strm.v.cap_dev = acc->cfg.vid_cap_dev;
-	    if (call_med->strm.v.rdr_dev == PJMEDIA_VID_DEFAULT_RENDER_DEV) {
-		pjmedia_vid_dev_info info;
-		pjmedia_vid_dev_get_info(call_med->strm.v.rdr_dev, &info);
-		call_med->strm.v.rdr_dev = info.id;
-	    }
-	    if (call_med->strm.v.cap_dev == PJMEDIA_VID_DEFAULT_CAPTURE_DEV) {
-		pjmedia_vid_dev_info info;
-		pjmedia_vid_dev_get_info(call_med->strm.v.cap_dev, &info);
-		call_med->strm.v.cap_dev = info.id;
-	    }
+	    status = pjsua_vid_channel_init(call_med);
+	    if (status != PJ_SUCCESS)
+		return status;
 	}
 #endif
 
-        set_media_tp_state(call_med, PJSUA_MED_TP_CREATING);
+        pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_CREATING);
 
 	if (pjsua_var.media_cfg.enable_ice) {
@@ -1515,5 +1258,5 @@
     } else if (call_med->tp_st == PJSUA_MED_TP_DISABLED) {
 	/* Media is being reenabled. */
-	set_media_tp_state(call_med, PJSUA_MED_TP_INIT);
+	pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_INIT);
     }
 
@@ -1616,5 +1359,5 @@
 	    }
 
-	    set_media_tp_state(call_med, PJSUA_MED_TP_INIT);
+	    pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_INIT);
 	}
     }
@@ -1881,5 +1624,5 @@
 		pj_assert(call_med->tp_st == PJSUA_MED_TP_INIT || 
 			  call_med->tp_st == PJSUA_MED_TP_RUNNING);
-		set_media_tp_state(call_med, PJSUA_MED_TP_DISABLED);
+		pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_DISABLED);
 	    }
 
@@ -2243,41 +1986,10 @@
 
 	if (call_med->type == PJMEDIA_TYPE_AUDIO) {
-	    pjmedia_stream *strm = call_med->strm.a.stream;
-	    pjmedia_rtcp_stat stat;
-
-	    if (strm) {
-		if (call_med->strm.a.conf_slot != PJSUA_INVALID_ID) {
-		    if (pjsua_var.mconf) {
-			pjsua_conf_remove_port(call_med->strm.a.conf_slot);
-		    }
-		    call_med->strm.a.conf_slot = PJSUA_INVALID_ID;
-		}
-
-		if ((call_med->dir & PJMEDIA_DIR_ENCODING) &&
-		    (pjmedia_stream_get_stat(strm, &stat) == PJ_SUCCESS))
-		{
-		    /* Save RTP timestamp & sequence, so when media session is
-		     * restarted, those values will be restored as the initial
-		     * RTP timestamp & sequence of the new media session. So in
-		     * the same call session, RTP timestamp and sequence are
-		     * guaranteed to be contigue.
-		     */
-		    call_med->rtp_tx_seq_ts_set = 1 | (1 << 1);
-		    call_med->rtp_tx_seq = stat.rtp_tx_last_seq;
-		    call_med->rtp_tx_ts = stat.rtp_tx_last_ts;
-		}
-
-		if (pjsua_var.ua_cfg.cb.on_stream_destroyed) {
-		    pjsua_var.ua_cfg.cb.on_stream_destroyed(call_id, strm, mi);
-		}
-
-		pjmedia_stream_destroy(strm);
-		call_med->strm.a.stream = NULL;
-	    }
+	    pjsua_aud_stop_stream(call_med);
 	}
 
 #if PJMEDIA_HAS_VIDEO
 	else if (call_med->type == PJMEDIA_TYPE_VIDEO) {
-	    stop_video_stream(call_med);
+	    pjsua_vid_stop_stream(call_med);
 	}
 #endif
@@ -2315,19 +2027,12 @@
     pj_log_push_indent();
 
+    stop_media_session(call_id);
+
     for (mi=0; mi<call->med_cnt; ++mi) {
 	pjsua_call_media *call_med = &call->media[mi];
 
-        if (call_med->type == PJMEDIA_TYPE_AUDIO && call_med->strm.a.stream)
-            pjmedia_stream_send_rtcp_bye(call_med->strm.a.stream);
-    }
-
-    stop_media_session(call_id);
-
-    for (mi=0; mi<call->med_cnt; ++mi) {
-	pjsua_call_media *call_med = &call->media[mi];
-
         if (call_med->tp_st > PJSUA_MED_TP_IDLE) {
 	    pjmedia_transport_media_stop(call_med->tp);
-	    set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
+	    pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
 	}
 
@@ -2345,5 +2050,4 @@
     }
 
-    check_snd_dev_idle();
     pj_log_pop_indent();
 
@@ -2351,243 +2055,4 @@
 }
 
-
-/*
- * DTMF callback from the stream.
- */
-static void dtmf_callback(pjmedia_stream *strm, void *user_data,
-			  int digit)
-{
-    PJ_UNUSED_ARG(strm);
-
-    pj_log_push_indent();
-
-    /* For discussions about call mutex protection related to this 
-     * callback, please see ticket #460:
-     *	http://trac.pjsip.org/repos/ticket/460#comment:4
-     */
-    if (pjsua_var.ua_cfg.cb.on_dtmf_digit) {
-	pjsua_call_id call_id;
-
-	call_id = (pjsua_call_id)(long)user_data;
-	pjsua_var.ua_cfg.cb.on_dtmf_digit(call_id, digit);
-    }
-
-    pj_log_pop_indent();
-}
-
-
-static pj_status_t audio_channel_update(pjsua_call_media *call_med,
-                                        pj_pool_t *tmp_pool,
-				        const pjmedia_sdp_session *local_sdp,
-				        const pjmedia_sdp_session *remote_sdp)
-{
-    pjsua_call *call = call_med->call;
-    pjmedia_stream_info the_si, *si = &the_si;
-    pjmedia_port *media_port;
-    unsigned strm_idx = call_med->idx;
-    pj_status_t status;
-
-    PJ_LOG(4,(THIS_FILE,"Audio channel update.."));
-    pj_log_push_indent();
-    
-    status = pjmedia_stream_info_from_sdp(si, tmp_pool, pjsua_var.med_endpt,
-                                          local_sdp, remote_sdp, strm_idx);
-    if (status != PJ_SUCCESS)
-	goto on_return;
-
-    si->rtcp_sdes_bye_disabled = PJ_TRUE;
-
-    /* Check if no media is active */
-    if (si->dir == PJMEDIA_DIR_NONE) {
-	/* Call media state */
-	call_med->state = PJSUA_CALL_MEDIA_NONE;
-
-	/* Call media direction */
-	call_med->dir = PJMEDIA_DIR_NONE;
-
-    } else {
-	pjmedia_transport_info tp_info;
-
-	/* Start/restart media transport */
-	status = pjmedia_transport_media_start(call_med->tp,
-					       tmp_pool, local_sdp,
-					       remote_sdp, strm_idx);
-	if (status != PJ_SUCCESS)
-	    goto on_return;
-
-	set_media_tp_state(call_med, PJSUA_MED_TP_RUNNING);
-
-	/* Get remote SRTP usage policy */
-	pjmedia_transport_info_init(&tp_info);
-	pjmedia_transport_get_info(call_med->tp, &tp_info);
-	if (tp_info.specific_info_cnt > 0) {
-	    unsigned i;
-	    for (i = 0; i < tp_info.specific_info_cnt; ++i) {
-		if (tp_info.spc_info[i].type == PJMEDIA_TRANSPORT_TYPE_SRTP) 
-		{
-		    pjmedia_srtp_info *srtp_info = 
-				(pjmedia_srtp_info*) tp_info.spc_info[i].buffer;
-
-		    call_med->rem_srtp_use = srtp_info->peer_use;
-		    break;
-		}
-	    }
-	}
-
-	/* Override ptime, if this option is specified. */
-	if (pjsua_var.media_cfg.ptime != 0) {
-	    si->param->setting.frm_per_pkt = (pj_uint8_t)
-		(pjsua_var.media_cfg.ptime / si->param->info.frm_ptime);
-	    if (si->param->setting.frm_per_pkt == 0)
-		si->param->setting.frm_per_pkt = 1;
-	}
-
-	/* Disable VAD, if this option is specified. */
-	if (pjsua_var.media_cfg.no_vad) {
-	    si->param->setting.vad = 0;
-	}
-
-
-	/* Optionally, application may modify other stream settings here
-	 * (such as jitter buffer parameters, codec ptime, etc.)
-	 */
-	si->jb_init = pjsua_var.media_cfg.jb_init;
-	si->jb_min_pre = pjsua_var.media_cfg.jb_min_pre;
-	si->jb_max_pre = pjsua_var.media_cfg.jb_max_pre;
-	si->jb_max = pjsua_var.media_cfg.jb_max;
-
-	/* Set SSRC */
-	si->ssrc = call_med->ssrc;
-
-	/* Set RTP timestamp & sequence, normally these value are intialized
-	 * automatically when stream session created, but for some cases (e.g:
-	 * call reinvite, call update) timestamp and sequence need to be kept
-	 * contigue.
-	 */
-	si->rtp_ts = call_med->rtp_tx_ts;
-	si->rtp_seq = call_med->rtp_tx_seq;
-	si->rtp_seq_ts_set = call_med->rtp_tx_seq_ts_set;
-
-#if defined(PJMEDIA_STREAM_ENABLE_KA) && PJMEDIA_STREAM_ENABLE_KA!=0
-	/* Enable/disable stream keep-alive and NAT hole punch. */
-	si->use_ka = pjsua_var.acc[call->acc_id].cfg.use_stream_ka;
-#endif
-
-	/* Create session based on session info. */
-	status = pjmedia_stream_create(pjsua_var.med_endpt, NULL, si,
-				       call_med->tp, NULL,
-				       &call_med->strm.a.stream);
-	if (status != PJ_SUCCESS) {
-	    goto on_return;
-	}
-
-	/* Start stream */
-	status = pjmedia_stream_start(call_med->strm.a.stream);
-	if (status != PJ_SUCCESS) {
-	    goto on_return;
-	}
-
-        if (call_med->prev_state == PJSUA_CALL_MEDIA_NONE)
-            pjmedia_stream_send_rtcp_sdes(call_med->strm.a.stream);
-
-	/* If DTMF callback is installed by application, install our
-	 * callback to the session.
-	 */
-	if (pjsua_var.ua_cfg.cb.on_dtmf_digit) {
-	    pjmedia_stream_set_dtmf_callback(call_med->strm.a.stream,
-					     &dtmf_callback,
-					     (void*)(long)(call->index));
-	}
-
-	/* Get the port interface of the first stream in the session.
-	 * We need the port interface to add to the conference bridge.
-	 */
-	pjmedia_stream_get_port(call_med->strm.a.stream, &media_port);
-
-	/* Notify application about stream creation.
-	 * Note: application may modify media_port to point to different
-	 * media port
-	 */
-	if (pjsua_var.ua_cfg.cb.on_stream_created) {
-	    pjsua_var.ua_cfg.cb.on_stream_created(call->index,
-						  call_med->strm.a.stream,
-						  strm_idx, &media_port);
-	}
-
-	/*
-	 * Add the call to conference bridge.
-	 */
-	{
-	    char tmp[PJSIP_MAX_URL_SIZE];
-	    pj_str_t port_name;
-
-	    port_name.ptr = tmp;
-	    port_name.slen = pjsip_uri_print(PJSIP_URI_IN_REQ_URI,
-					     call->inv->dlg->remote.info->uri,
-					     tmp, sizeof(tmp));
-	    if (port_name.slen < 1) {
-		port_name = pj_str("call");
-	    }
-	    status = pjmedia_conf_add_port( pjsua_var.mconf, 
-					    call->inv->pool_prov,
-					    media_port, 
-					    &port_name,
-					    (unsigned*)
-					    &call_med->strm.a.conf_slot);
-	    if (status != PJ_SUCCESS) {
-		goto on_return;
-	    }
-	}
-
-	/* Call media direction */
-	call_med->dir = si->dir;
-
-	/* Call media state */
-	if (call->local_hold)
-	    call_med->state = PJSUA_CALL_MEDIA_LOCAL_HOLD;
-	else if (call_med->dir == PJMEDIA_DIR_DECODING)
-	    call_med->state = PJSUA_CALL_MEDIA_REMOTE_HOLD;
-	else
-	    call_med->state = PJSUA_CALL_MEDIA_ACTIVE;
-    }
-
-    /* Print info. */
-    {
-	char info[80];
-	int info_len = 0;
-	int len;
-	const char *dir;
-
-	switch (si->dir) {
-	case PJMEDIA_DIR_NONE:
-	    dir = "inactive";
-	    break;
-	case PJMEDIA_DIR_ENCODING:
-	    dir = "sendonly";
-	    break;
-	case PJMEDIA_DIR_DECODING:
-	    dir = "recvonly";
-	    break;
-	case PJMEDIA_DIR_ENCODING_DECODING:
-	    dir = "sendrecv";
-	    break;
-	default:
-	    dir = "unknown";
-	    break;
-	}
-	len = pj_ansi_sprintf( info+info_len,
-			       ", stream #%d: %.*s (%s)", strm_idx,
-			       (int)si->fmt.encoding_name.slen,
-			       si->fmt.encoding_name.ptr,
-			       dir);
-	if (len > 0)
-	    info_len += len;
-	PJ_LOG(4,(THIS_FILE,"Audio updated%s", info));
-    }
-
-on_return:
-    pj_log_pop_indent();
-    return status;
-}
 
 pj_status_t pjsua_media_channel_update(pjsua_call_id call_id,
@@ -2690,23 +2155,236 @@
 	}
 
-	switch (call_med->type) {
-	case PJMEDIA_TYPE_AUDIO:
-	    status = audio_channel_update(call_med, tmp_pool,
-	                                  local_sdp, remote_sdp);
+	if (call_med->type==PJMEDIA_TYPE_AUDIO) {
+	    pjmedia_stream_info the_si, *si = &the_si;
+
+	    status = pjmedia_stream_info_from_sdp(si, tmp_pool, pjsua_var.med_endpt,
+	                                          local_sdp, remote_sdp, mi);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status,
+			     "pjmedia_stream_info_from_sdp() failed "
+			         "for call_id %d media %d",
+			     call_id, mi));
+		continue;
+	    }
+
+	    /* Check if no media is active */
+	    if (si->dir == PJMEDIA_DIR_NONE) {
+		/* Update call media state and direction */
+		call_med->state = PJSUA_CALL_MEDIA_NONE;
+		call_med->dir = PJMEDIA_DIR_NONE;
+
+	    } else {
+		pjmedia_transport_info tp_info;
+
+		/* Start/restart media transport based on info in SDP */
+		status = pjmedia_transport_media_start(call_med->tp,
+						       tmp_pool, local_sdp,
+						       remote_sdp, mi);
+		if (status != PJ_SUCCESS) {
+		    PJ_PERROR(1,(THIS_FILE, status,
+				 "pjmedia_transport_media_start() failed "
+				     "for call_id %d media %d",
+				 call_id, mi));
+		    continue;
+		}
+
+		pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_RUNNING);
+
+		/* Get remote SRTP usage policy */
+		pjmedia_transport_info_init(&tp_info);
+		pjmedia_transport_get_info(call_med->tp, &tp_info);
+		if (tp_info.specific_info_cnt > 0) {
+		    unsigned i;
+		    for (i = 0; i < tp_info.specific_info_cnt; ++i) {
+			if (tp_info.spc_info[i].type == PJMEDIA_TRANSPORT_TYPE_SRTP)
+			{
+			    pjmedia_srtp_info *srtp_info =
+					(pjmedia_srtp_info*) tp_info.spc_info[i].buffer;
+
+			    call_med->rem_srtp_use = srtp_info->peer_use;
+			    break;
+			}
+		    }
+		}
+
+		/* Call media direction */
+		call_med->dir = si->dir;
+
+		/* Call media state */
+		if (call->local_hold)
+		    call_med->state = PJSUA_CALL_MEDIA_LOCAL_HOLD;
+		else if (call_med->dir == PJMEDIA_DIR_DECODING)
+		    call_med->state = PJSUA_CALL_MEDIA_REMOTE_HOLD;
+		else
+		    call_med->state = PJSUA_CALL_MEDIA_ACTIVE;
+	    }
+
+	    /* Call implementation */
+	    status = pjsua_aud_channel_update(call_med, tmp_pool, si,
+	                                      local_sdp, remote_sdp);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status,
+			     "pjsua_aud_channel_update() failed "
+				 "for call_id %d media %d",
+			     call_id, mi));
+		continue;
+	    }
+
+	    /* Print info. */
+	    if (status == PJ_SUCCESS) {
+		char info[80];
+		int info_len = 0;
+		int len;
+		const char *dir;
+
+		switch (si->dir) {
+		case PJMEDIA_DIR_NONE:
+		    dir = "inactive";
+		    break;
+		case PJMEDIA_DIR_ENCODING:
+		    dir = "sendonly";
+		    break;
+		case PJMEDIA_DIR_DECODING:
+		    dir = "recvonly";
+		    break;
+		case PJMEDIA_DIR_ENCODING_DECODING:
+		    dir = "sendrecv";
+		    break;
+		default:
+		    dir = "unknown";
+		    break;
+		}
+		len = pj_ansi_sprintf( info+info_len,
+				       ", stream #%d: %.*s (%s)", mi,
+				       (int)si->fmt.encoding_name.slen,
+				       si->fmt.encoding_name.ptr,
+				       dir);
+		if (len > 0)
+		    info_len += len;
+		PJ_LOG(4,(THIS_FILE,"Audio updated%s", info));
+	    }
+
+
 	    if (call->audio_idx==-1 && status==PJ_SUCCESS &&
-		call_med->strm.a.stream)
+		si->dir != PJMEDIA_DIR_NONE)
 	    {
 		call->audio_idx = mi;
 	    }
-	    break;
+
 #if defined(PJMEDIA_HAS_VIDEO) && (PJMEDIA_HAS_VIDEO != 0)
-	case PJMEDIA_TYPE_VIDEO:
-	    status = video_channel_update(call_med, tmp_pool,
-	                                  local_sdp, remote_sdp);
-	    break;
+	} else if (call_med->type==PJMEDIA_TYPE_VIDEO) {
+	    pjmedia_vid_stream_info the_si, *si = &the_si;
+
+	    status = pjmedia_vid_stream_info_from_sdp(si, tmp_pool, pjsua_var.med_endpt,
+						      local_sdp, remote_sdp, mi);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status,
+			     "pjmedia_vid_stream_info_from_sdp() failed "
+			         "for call_id %d media %d",
+			     call_id, mi));
+		continue;
+	    }
+
+	    /* Check if no media is active */
+	    if (si->dir == PJMEDIA_DIR_NONE) {
+		/* Call media state */
+		call_med->state = PJSUA_CALL_MEDIA_NONE;
+
+		/* Call media direction */
+		call_med->dir = PJMEDIA_DIR_NONE;
+
+	    } else {
+		pjmedia_transport_info tp_info;
+
+		/* Start/restart media transport */
+		status = pjmedia_transport_media_start(call_med->tp,
+						       tmp_pool, local_sdp,
+						       remote_sdp, mi);
+		if (status != PJ_SUCCESS) {
+		    PJ_PERROR(1,(THIS_FILE, status,
+				 "pjmedia_transport_media_start() failed "
+				     "for call_id %d media %d",
+				 call_id, mi));
+		    continue;
+		}
+
+		pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_RUNNING);
+
+		/* Get remote SRTP usage policy */
+		pjmedia_transport_info_init(&tp_info);
+		pjmedia_transport_get_info(call_med->tp, &tp_info);
+		if (tp_info.specific_info_cnt > 0) {
+		    unsigned i;
+		    for (i = 0; i < tp_info.specific_info_cnt; ++i) {
+			if (tp_info.spc_info[i].type ==
+				PJMEDIA_TRANSPORT_TYPE_SRTP)
+			{
+			    pjmedia_srtp_info *sri;
+			    sri=(pjmedia_srtp_info*)tp_info.spc_info[i].buffer;
+			    call_med->rem_srtp_use = sri->peer_use;
+			    break;
+			}
+		    }
+		}
+
+		/* Call media direction */
+		call_med->dir = si->dir;
+
+		/* Call media state */
+		if (call->local_hold)
+		    call_med->state = PJSUA_CALL_MEDIA_LOCAL_HOLD;
+		else if (call_med->dir == PJMEDIA_DIR_DECODING)
+		    call_med->state = PJSUA_CALL_MEDIA_REMOTE_HOLD;
+		else
+		    call_med->state = PJSUA_CALL_MEDIA_ACTIVE;
+	    }
+
+	    status = pjsua_vid_channel_update(call_med, tmp_pool, si,
+	                                      local_sdp, remote_sdp);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status,
+			     "pjmedia_transport_media_start() failed "
+				 "for call_id %d media %d",
+			     call_id, mi));
+		continue;
+	    }
+
+	    /* Print info. */
+	    {
+		char info[80];
+		int info_len = 0;
+		int len;
+		const char *dir;
+
+		switch (si->dir) {
+		case PJMEDIA_DIR_NONE:
+		    dir = "inactive";
+		    break;
+		case PJMEDIA_DIR_ENCODING:
+		    dir = "sendonly";
+		    break;
+		case PJMEDIA_DIR_DECODING:
+		    dir = "recvonly";
+		    break;
+		case PJMEDIA_DIR_ENCODING_DECODING:
+		    dir = "sendrecv";
+		    break;
+		default:
+		    dir = "unknown";
+		    break;
+		}
+		len = pj_ansi_sprintf( info+info_len,
+				       ", stream #%d: %.*s (%s)", mi,
+				       (int)si->codec_info.encoding_name.slen,
+				       si->codec_info.encoding_name.ptr,
+				       dir);
+		if (len > 0)
+		    info_len += len;
+		PJ_LOG(4,(THIS_FILE,"Video updated%s", info));
+	    }
+
 #endif
-	default:
+	} else {
 	    status = PJMEDIA_EINVALIMEDIATYPE;
-	    break;
 	}
 
@@ -2718,5 +2396,5 @@
 	    pjmedia_transport_close(call_med->tp);
 	    call_med->tp = call_med->tp_orig = NULL;
-	    set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
+	    pjsua_set_media_tp_state(call_med, PJSUA_MED_TP_IDLE);
 	}
 
